unit CpuUsage;

{$mode ObjFPC}{$H+}

// see https://www.lazarusforum.de/viewtopic.php?t=11997

interface

uses
  Classes,
  SysUtils,
  JwaWinBase;

var
  FLastIdleTime   : Int64;
  FLastKernelTime : Int64;
  FLastUserTime   : Int64;

function get_cpu_last:double;


implementation

(******************)
(* CPU-Last holen *)
(******************)
function get_cpu_last:double;
{$PUSH}
{$CODEALIGN LOCALMIN=8}
var
  IdleTimeRec   : TFileTime;
  KernelTimeRec : TFileTime;
  UserTimeRec   : TFileTime;
  IdleTime      : Int64 absolute IdleTimeRec;
  KernelTime    : Int64 absolute KernelTimeRec;
  UserTime      : Int64 absolute UserTimeRec;
  IdleDiff      : Int64;
  KernelDiff    : Int64;
  UserDiff      : Int64;
  SysTime       : Int64;
{$POP}
var
  last : double;
begin
  if GetSystemTimes( @IdleTimeRec, @KernelTimeRec, @UserTimeRec)
    then
      begin
        IdleDiff        := IdleTime - FLastIdleTime;
        KernelDiff      := KernelTime - FLastKernelTime;
        UserDiff        := UserTime - FLastUserTime;
        FLastIdleTime   := IdleTime;
        FLastKernelTime := KernelTime;
        FLastUserTime   := UserTime;
        SysTime         := KernelDiff +UserDiff;
        last            :=(SysTime - IdleDiff) / SysTime * 100;
        result:= last;
      end
    else result:= 0;
end;


end.

